package tw.edu.scu.csim.coin;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.drawable.BitmapDrawable;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;

public class Game extends Activity implements SensorEventListener {
	private int				screenWidth, screenHeight;				// ùe
	private int				level		= 10;						// w
																	// Random
																	// ran = new
																	// Random();
	private int				speed		= 10;						// Ut
	private int				score		= 0;						// 
	private int				time		= 30000;					// Cɶ(1000=1)
	private Canvas			canvas;
	private ArrayList<Coin>	coins		= new ArrayList<Coin>();
	private MyCountDown		cdTimer;								// ˼ƭpɾ
	private String			remainingTime;							// Ѿlɶ
	Thread					mainLoop;
	CoinMove				coinMove;								// 渨Uʧ@
	private boolean			terminate	= false;					// BzThread
	Bitmap					box;
	private int				boxLeft;
	private int				boxTop;
	private int             count = 1;

	private SensorManager	senorManager;

	/* eøXPĲIƥ */
	class MySurfaceView extends SurfaceView implements Runnable {
		BitmapDrawable	background;
		Paint			paint	= new Paint();

		public MySurfaceView(Context context) {
			super(context);

			/* oùe */
			DisplayMetrics dm = new DisplayMetrics();
			getWindowManager().getDefaultDisplay().getMetrics(dm);
			screenWidth = dm.widthPixels;
			screenHeight = dm.heightPixels;

			Log.i("w", String.valueOf(screenWidth));
			Log.i("h", String.valueOf(screenHeight));

			/* ]wI */
			Bitmap bitmap = BitmapFactory.decodeResource(context.getResources(), R.drawable.grid1);
			background = new BitmapDrawable(context.getResources(), bitmap);
			background.setBounds(0, 0, screenWidth, screenHeight);

			/* ]wcl */
			box = BitmapFactory.decodeResource(getResources(), R.drawable.pooman2);
			boxLeft = (screenWidth - box.getWidth()) / 2;
			boxTop = screenHeight - box.getHeight()/3*2;

			paint.setColor(Color.BLACK);
			paint.setTextSize(18);

			initilizeGame(context); // HmϤm

			mainLoop = new Thread(this);
			mainLoop.start();
		}

		/* eøX */
		void doDraw() {
			canvas = getHolder().lockCanvas();
			if (canvas != null) {
				background.draw(canvas);

				for (int i = 0; i < coins.size(); i++) {
					Bitmap bitmap = coins.get(i).bitmap;
					int left = coins.get(i).left;
					int top = coins.get(i).top;

					canvas.drawBitmap(bitmap, left, top, null);
				}

				String s = "ìG" + String.valueOf(score);
				canvas.drawText(s, 5, 40, paint); // eX
				canvas.drawText(remainingTime, 5, 20, paint); // eXѾl
				canvas.drawBitmap(box, boxLeft, boxTop, null);
				if(count==0)
					canvas.drawARGB(255, 255, 255, 255);
				getHolder().unlockCanvasAndPost(canvas);
				
			}
		}

		public void run() {
			while (!terminate) {
				doDraw();
			}
		}
	}

	/* wUt */
	class CoinMove extends Thread {
		void doMove() {
			Random r = new Random();
			for (int i = 0; i < coins.size(); i++) {
				int t = 1;
				// for(int t=1;t<=2;t++){
				coins.get(i).top += 4 * t;
				coins.get(i).left += coins.get(i).aa * t;// UT
				// }
				int coinRange = coins.get(i).top + coins.get(i).bitmap.getHeight();

				if (coinRange < boxTop) {
					// 
				} else if (coins.get(i).top > screenHeight) {
					coins.set(i, ResetCoin()); // m]Xew
				} else if (coinRange > boxTop) {
					int coinWidth = coins.get(i).left + coins.get(i).bitmap.getWidth();

					// Ywclho
					if (coins.get(i).left > boxLeft && coinWidth < boxLeft + box.getWidth()) {
						score += coins.get(i).dollar; // [
						coins.set(i, ResetCoin());
					}
				}
			}

			try {
				Thread.sleep(20); // mstv
			} catch (Exception ex) {
			}
		}

		public void run() {
			while (!terminate) {
				doMove();
			}
		}
	}

	/* ˼ƭpɾ */
	public class MyCountDown extends CountDownTimer {
		Context	context;

		public MyCountDown(long millisInFuture, long countDownInterval, Context context) {
			super(millisInFuture, countDownInterval);
			this.context = context;
		}

		@Override
		public void onFinish() {
			remainingTime = "Ѿlɶ: 0 ";
            count=0;
			Button button = new Button(context);
			button.setText("Tw");
			final Dialog dialog = new Dialog(context);
			dialog.setTitle("ߧAo " + score + "I");
			dialog.setContentView(button);
			dialog.show();
			button.setOnClickListener(new OnClickListener() {
				public void onClick(View v) {
					dialog.dismiss();
					Game.this.finish();
				}
			});
		}

		@Override
		public void onTick(long millisUntilFinished) {
			remainingTime = "Ѿlɶ: " + (millisUntilFinished / 1000 + 1) + " ";
		}
	}

	/* NϭsbeWHm */
	private void initilizeGame(Context context) {
		coins.clear();

		for (int i = 0; i < level; i++) {
			Coin coin = ResetCoin();
			coins.add(coin);
		}

		score = 0; // m

		cdTimer = new MyCountDown(time, 500, context); // ˼ƭpɾ
		cdTimer.start();

		coinMove = new CoinMove(); // BzwʪThread
		coinMove.start();
	}

	/* Hͤ@ӵw */
	private Coin ResetCoin() {
		Random r = new Random();

		Bitmap bitmap;
		int dollar = 10;
		int j = r.nextInt(100);
		if (j < 70) {
			// 10
			bitmap = BitmapFactory.decodeResource(this.getResources(), R.drawable.coin10);
		} else if (j < 90) {
			// 20
			dollar = 20;
			bitmap = BitmapFactory.decodeResource(this.getResources(), R.drawable.coin20);
		} else {
			// 50
			dollar = 50;
			bitmap = BitmapFactory.decodeResource(this.getResources(), R.drawable.coin50);
		}
		// int top = bitmap.getHeight();
		// int left = bitmap.getWidth();
		// int left = r.nextInt(screenWidth - bitmap.getWidth());
		int left = (int) (0 - bitmap.getWidth() - r.nextInt(screenWidth) * 1.5);
		int top = 0 - bitmap.getHeight() - r.nextInt(screenHeight) * 2;
		int a = 0;
		Coin coin = new Coin(bitmap, dollar, left, top, a);

		return coin;
	}

	@Override
	protected void onCreate(final Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		senorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
		setContentView(new MySurfaceView(this));
	}

	@Override
	protected void onResume() {
		super.onResume();
		List<Sensor> sensors = senorManager.getSensorList(Sensor.TYPE_ORIENTATION);
		if (sensors.size() > 0) {
			senorManager.registerListener(this, sensors.get(0), SensorManager.SENSOR_DELAY_FASTEST);
		}
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		terminate = true;
		mainLoop.interrupt();
		coinMove.interrupt();
		cdTimer.cancel();
	}

	@Override
	protected void onPause() {
		super.onPause();
		senorManager.unregisterListener(this);
	}

	public void onAccuracyChanged(Sensor arg0, int arg1) {
		// TODO Auto-generated method stub

	}

	public void onSensorChanged(SensorEvent event) {
		// TODO Auto-generated method stub
		if (event.values[1] > 0&&event.values[1] > 5) {
			if(boxLeft>0)
			boxLeft = boxLeft - 5;
		}
		 if (event.values[1] > 5&&event.values[1] > 15)
		{
			 if(boxLeft>0)
			boxLeft = boxLeft - 5;
		}
		 if (event.values[1] > 10&&event.values[1] > 20)
		{
			 if(boxLeft>0)
			boxLeft = boxLeft - 5;
		}
		
		
		if (event.values[1] < 0&&event.values[1] < -5) {
			
			if(boxLeft+box.getWidth()<screenWidth)
			boxLeft = boxLeft + 5;
		}
		 if (event.values[1] < -5&&event.values[1] < -15)
		{
			 if(boxLeft+box.getWidth()<screenWidth)
			boxLeft = boxLeft + 5;
		}
		 if (event.values[1] < -10&&event.values[1] < -20)
		{
			 if(boxLeft+box.getWidth()<screenWidth)
			boxLeft = boxLeft + 5;
		}
		
	}
}
